#!/usr/bin/python
#
# add a rhel or centos 6 system to Windows active directory
# and/or install any of the Linux Security tools

import sys, os, getopt, subprocess, time, imp, re

# don't go any further unless this is a privileged acct
if os.geteuid() != 0:
  exit("You need to either use sudo or be root to execute this script.")

# confirm this is either RHEL or CentOS
if not os.path.exists("/etc/redhat-release"):
  exit("This script works on RHEL or CentOS systems only.")
  sys.exit(1)


def usage():
  print "\nUsage: " + sys.argv[0] + """ [ -a <adm_acct> -i -m -e]\n
  This script is meant to aid system administrators in adding a rhel/centos system
  to OUR AD and installing the requisite security tools. Requires at least one of following arguments:
          -a or --adadmin=        Name of AD Admin Account to use
          -i or --iem             Install and configure IBM Endpoint Manager
          -m or --mcafee          Install and configure McAfee Anti Virus
          -e or --encase          Install and configure Encase Forensics Software

  Exit Codes:
           0    All Good
           4    User exit after requisite rpms were not found
  """
  sys.exit(1)

# from ActiveState Recipe 577058
def query_yes_no(question, default="yes"):
  """Ask a yes/no question via raw_input() and return their answer.
     "question" is a string that is presented to the user.
     "default" is the presumed answer if the user just hits <Enter>.
        It must be "yes" (the default), "no" or None (meaning
        an answer is required of the user).
     The "answer" return value is one of "yes" or "no".
  """
  valid = {"yes":"yes",   "y":"yes",  "ye":"yes",
           "no":"no",     "n":"no"}
  if default == None:
    prompt = " [y/n] "
  elif default == "yes":
    prompt = " [Y/n] "
  elif default == "no":
    prompt = " [y/N] "
  else:
    raise ValueError("invalid default answer: '%s'" % default)

  while 1:
    sys.stdout.write(question + prompt)
    choice = raw_input().lower()
    if default is not None and choice == '':
      return default
    elif choice in valid.keys():
      return valid[choice]
    else:
      sys.stdout.write("Please respond with 'yes' or 'no' "\
                       "(or 'y' or 'n').\n")


def chk_pkgs(*argv):
  try:
    if imp.find_module('yum'):
      print "python yum module found, proceeding to check for requisite rpm packages..."
      import yum
      yb = yum.YumBase()
      required_rpms = argv
      needed_rpms = []
      for r in required_rpms:
        if not yb.rpmdb.searchNevra(name=r):
          needed_rpms.append(r)
      if needed_rpms:
       needed_rpms_string = ' '.join(needed_rpms)
       print "The following requisite packages must be installed: " + needed_rpms_string
       choice = query_yes_no("Do you wish to install these? ", default="yes")
       if choice == "yes":
         os.system("yum -y install %s" % (needed_rpms_string))
  except ImportError:
    choice = query_yes_no("Warning: could not check for requisite rpm packages. Continue Anyways? ", default="yes")
    if choice == "no":
      sys.exit(4)

def add_to_ad(admacct):

  # add the correct kerberos configuration
  krb5file = "/etc/krb5.conf"
  if os.path.exists(krb5file):
    os.rename(krb5file, krb5file + ".bak")

  mitkrb5 = """[logging]
 default = FILE:/var/log/krb5libs.log
 kdc = FILE:/var/log/krb5kdc.log
 admin_server = FILE:/var/log/kadmind.log

[libdefaults]
 default_realm = OUR.AD.LOCAL
 dns_lookup_realm = false
 dns_lookup_kdc = false
 ticket_lifetime = 24h
 ticket_lifetime = 7d
 forwardable = yes
 default_tgs_enctypes = arcfour-hmac-md5 des3-hmac-sha1 RC4-HMAC DES-CBC-MD5 DES-CBC-CRC
 default_tkt_enctypes = arcfour-hmac-md5 des3-hmac-sha1 RC4-HMAC DES-CBC-MD5 DES-CBC-CRC
 clockskew = 300
 default_keytab_name = FILE:/etc/krb5.keytab

[realms]
 OUR.AD.LOCAL = {
  kdc = lladdc01.ad.local:88
  admin_server = lladdc01.ad.local:749
  default_domain = ad.local
 }

[domain_realm]
 .ad.local = OUR.AD.LOCAL
 ad.local = OUR.AD.LOCAL
 .lan.our.com = OUR.AD.LOCAL
 lan.our.com = OUR.AD.LOCAL

[appdefaults]
 pam = {
   debug = false
   ticket_lifetime = 24h
   renew_lifetime = 7d
   forwardable = true
   proxiable = false
   retain_after_close = false
   minimum_uid = 500
   try_first_pass = true
   validate = true
 }
"""

  newkrb5 = open(krb5file, "w")
  newkrb5.write(mitkrb5)
  newkrb5.close

  # add the correct samba configuration
  smbfile = "/etc/samba/smb.conf"
  if os.path.exists(smbfile):
    os.rename(smbfile, smbfile + ".bak")

  mitsmb = """#======================= Global Settings =====================================
[global]
#--authconfig--start-line--
# Generated by authconfig on 2013/09/19 10:32:40
# DO NOT EDIT THIS SECTION (delimited by --start-line--/--end-line--)
# Any modification may be deleted or altered by authconfig in future

   workgroup = OUR
   security = ADS
   realm = OUR.AD.LOCAL
   kerberos method = secrets and keytab
   winbind refresh tickets = yes
   template shell = /bin/bash
   template homedir = /home/%U
   winbind use default domain = yes
   winbind offline logon = yes
   winbind separator = ~

#--authconfig--end-line--

   preferred master = no
   encrypt passwords = yes
   winbind nested groups = yes
   allow trusted domains = no
   idmap config OUR.AD.LOCAL:backend = rid
   idmap config OUR.AD.LOCAL:base_rid = 0
   idmap config OUR.AD.LOCAL:range = 1000-33554432
   idmap config *:backend = rid
   idmap config *:base_rid = 0
   idmap config *:range = 1000-33554432
   server signing = auto
   client signing = auto
   client use spnego = yes
   ntlm auth = yes
   lanman auth = no

# ----------------------- Network Related Options -------------------------
	server string = Samba Server Version %v

# --------------------------- Socket Options -----------------------------

socket options = TCP_NODELAY IPTOS_LOWDELAY SO_KEEPALIVE SO_RCVBUF=8192 SO_SNDBUF=8192

# --------------------------- Logging Options -----------------------------

   log level = 3
   log file = /var/log/samba/log.%m
   max log size = 50

# --------------------------- Printing Options -----------------------------

   load printers = no
   printcap name = /dev/null
   disable spoolss = yes

#============================ Share Definitions ==============================
#
#[data]
#    path = /data
#    guest ok = no
#    browseable = yes
##    public = yes
#    writable = yes
#    available = yes
#    valid users = some_local_acct, "@0999-everyone"
#
"""

  newsmb = open(smbfile, "w")
  newsmb.write(mitsmb)
  newsmb.close


# Note: /etc/pam.d/system-auth file is a symlink to the file referenced below

  pamsysauthacfile = "/etc/pam.d/system-auth-ac"
  if os.path.exists(pamsysauthacfile):
    os.rename(pamsysauthacfile, pamsysauthacfile + ".bak")

  mitpamsysauthac = """#%PAM-1.0
# This file is auto-generated.
# User changes will be destroyed the next time authconfig is run.
auth        required      pam_env.so
auth        sufficient    pam_fprintd.so
auth        sufficient    pam_unix.so nullok try_first_pass
auth        requisite     pam_succeed_if.so uid >= 500 quiet
auth        sufficient    pam_winbind.so cached_login use_first_pass
auth        required      pam_deny.so

account     required      pam_access.so
account     required      pam_unix.so broken_shadow
account     sufficient    pam_localuser.so
account     sufficient    pam_succeed_if.so uid < 500 quiet
account     [default=bad success=ok user_unknown=ignore] pam_winbind.so cached_login
account     required      pam_permit.so

password    requisite     pam_cracklib.so try_first_pass retry=3 type=
password    sufficient    pam_unix.so sha512 shadow nullok try_first_pass use_authtok
password    sufficient    pam_winbind.so cached_login use_authtok
password    required      pam_deny.so

session     optional      pam_keyinit.so revoke
session     required      pam_limits.so
session     optional      pam_mkhomedir.so umask=0077
session     [success=1 default=ignore] pam_succeed_if.so service in crond quiet use_uid
session     required      pam_unix.so
"""

  newpamsysauthac = open(pamsysauthacfile, "w")
  newpamsysauthac.write(mitpamsysauthac)
  newpamsysauthac.close

# Note /etc/pam.d/password-auth file is also a symlink to the below
  pampwauthacfile = "/etc/pam.d/password-auth-ac"
  if os.path.exists(pampwauthacfile):
    os.rename(pampwauthacfile, pampwauthacfile + ".bak")

  mitpampwauthac = """#%PAM-1.0
# This file is auto-generated.
# User changes will be destroyed the next time authconfig is run.
auth        required      pam_env.so
auth        sufficient    pam_unix.so try_first_pass
auth        requisite     pam_succeed_if.so uid >= 500 quiet
auth        sufficient    pam_winbind.so cached_login use_first_pass
auth        required      pam_deny.so

account     required      pam_unix.so broken_shadow
account     sufficient    pam_localuser.so
account     sufficient    pam_succeed_if.so uid < 500 quiet
account     [default=bad success=ok user_unknown=ignore] pam_winbind.so cached_login
account     required      pam_permit.so

password    requisite     pam_cracklib.so try_first_pass retry=3 minlen=12 difok=4 dcredit=-1 ucredit=-1 ocredit=-1 lcredit=-1
password    sufficient    pam_unix.so sha512 shadow try_first_pass use_authtok
password    sufficient    pam_winbind.so cached_login use_authtok
password    required      pam_deny.so

session     optional      pam_keyinit.so revoke
session     required      pam_limits.so
session     optional      pam_oddjob_mkhomedir.so
session     [success=1 default=ignore] pam_succeed_if.so service in crond quiet use_uid
session     required      pam_unix.so
"""
  newpampwauthac = open(pampwauthacfile, "w")
  newpampwauthac.write(mitpampwauthac)
  newpampwauthac.close


  nssfile = "/etc/nsswitch.conf"
  if os.path.exists(nssfile):
    os.rename(nssfile, nssfile + ".bak")

  mitnss = """#
# /etc/nsswitch.conf
#
# An example Name Service Switch config file. This file should be
# sorted with the most-used services at the beginning.
#
# The entry '[NOTFOUND=return]' means that the search for an
# entry should stop if the search in the previous entry turned
# up nothing. Note that if the search failed due to some other reason
# (like no NIS server responding) then the search continues with the
# next entry.
#
# Valid entries include:
#
#	nisplus			Use NIS+ (NIS version 3)
#	nis			Use NIS (NIS version 2), also called YP
#	dns			Use DNS (Domain Name Service)
#	files			Use the local files
#	db			Use the local database (.db) files
#	compat			Use NIS on compat mode
#	hesiod			Use Hesiod for user lookups
#	[NOTFOUND=return]	Stop searching if not found so far
#

# To use db, put the "db" in front of "files" for entries you want to be
# looked up first in the databases
#
# Example:
#passwd:    db files nisplus nis
#shadow:    db files nisplus nis
#group:     db files nisplus nis

passwd:     files winbind
shadow:     files winbind
group:      files winbind

#hosts:     db files nisplus nis dns
hosts:      files dns

# Example - obey only what nisplus tells us...
#services:   nisplus [NOTFOUND=return] files
#networks:   nisplus [NOTFOUND=return] files
#protocols:  nisplus [NOTFOUND=return] files
#rpc:        nisplus [NOTFOUND=return] files
#ethers:     nisplus [NOTFOUND=return] files
#netmasks:   nisplus [NOTFOUND=return] files     

bootparams: nisplus [NOTFOUND=return] files

ethers:     files
netmasks:   files
networks:   files
protocols:  files
rpc:        files
services:   files

netgroup:   files

publickey:  nisplus

automount:  files
aliases:    files nisplus
"""

  newnss = open(nssfile, "w")
  newnss.write(mitnss)
  newnss.close

  sysauthfile = "/etc/sysconfig/authconfig"
  if os.path.exists(sysauthfile):
    os.rename(sysauthfile, sysauthfile + ".bak")

  mitsysauth = """IPADOMAINJOINED=no
USEMKHOMEDIR=yes
USEPAMACCESS=yes
CACHECREDENTIALS=yes
USESSSDAUTH=no
USESHADOW=yes
USEWINBIND=yes
PASSWDALGORITHM=sha512
FORCELEGACY=no
USEFPRINTD=yes
FORCESMARTCARD=no
USEDB=no
USELDAPAUTH=no
USEPASSWDQC=no
IPAV2NONTP=no
USELOCAUTHORIZE=yes
USECRACKLIB=yes
USEIPAV2=no
USEWINBINDAUTH=yes
USESMARTCARD=no
USELDAP=no
USENIS=no
USEKERBEROS=no
USESYSNETAUTH=no
USESSSD=no
USEHESIOD=no
"""

  newsysauth = open(sysauthfile, "w")
  newsysauth.write(mitsysauth)
  newsysauth.close

  # Add to sudoers
  with open("/etc/sudoers", "a") as sudoersfile:
    sudoersfile.write("""
## Allow Administrators unfettered access
%0123-Administrators    ALL=(ALL)       NOPASSWD: ALL
%0123-IT        ALL=(ALL)       NOPASSWD: ALL
""")
    sudoersfile.close

  # system calls to add to AD - smb & winbind services need to be turned on if they were just installed
  os.system("service ntpd stop; service ntpdate stop; chkconfig ntpdate off; chkconfig ntpd on; chkconfig smb on; chkconfig winbind on; chkconfig oddjobd on")
  os.system("ntpdate ntp1.lan.our.com")
  os.system("kdestroy; kinit %s@OUR.AD.LOCAL" % (admacct))
  # sometimes fails here...try starting windows services and add a sleep?
  os.system("service smb start; service winbind start")
  os.system("net ads join -U %s@OUR.AD.LOCAL" % (admacct))
  print("AD system configuration complete. Please reboot system to take effect.")


def main(argv=None):

  http_repo = "http://spacewalk/custom"
  iem_rpm = "iem-9.2.1.48_rhe5-1.el6.x86_64.rpm"
  mcafee_rpm = "mcafee64-6.0.4-2.el6.x86_64.rpm"
  encase_rpm = "encase-7.9.4.31-1.el6.x86_64.rpm"
  install_iem = False
  install_mcafee = False
  install_encase = False
  ad_admin = None

  if argv is None:
    argv = sys.argv

  try:
    opts, args = getopt.getopt(argv, "himea:", ["help", "iem", "mcafee", "encase", "adadmin="])
  except getopt.GetoptError:
    usage()
    sys.exit(2)

  # get arguments from command line
  for opt, arg in opts:
    if opt in ("-h", "--help"):
      usage()
      sys.exit()
    elif opt in ("-i", "--iem"):
      install_iem = True
    elif opt in ("-m", "--mcafee"):
      install_mcafee = True
    elif opt in ("-e", "--encase"):
      install_encase = True
    elif opt in ("-a", "--adadmin"):
      ad_admin = arg

  # We need at least one valid argument
  if len(sys.argv) == 1:
    usage()
    sys.exit()
  elif not (install_iem or install_mcafee or install_encase or ad_admin) :
    usage()
    sys.exit(1)


  # Identify if this is a RHEL/CentOS 5/6/7 system for package dependencies
  try:
    kver = os.popen("uname -r").read().rstrip()
  except:
    kver = ""

  # If the argument was given to do so here
  if install_iem:
    print "Installing %s from %s..." % (iem_rpm, http_repo)
    os.system("rpm -Uvh %s/%s" % (http_repo, iem_rpm))

  # If the argument was given to do so here
  if install_mcafee:
    print "Installing %s from %s..." % (mcafee_rpm, http_repo)
    os.system("rpm -Uvh %s/%s" % (http_repo, mcafee_rpm))

  # If the argument was given to do so here
  if install_encase:
    print "Installing %s from %s..." % (encase_rpm, http_repo)
    os.system("rpm -Uvh %s/%s" % (http_repo, encase_rpm))

  # If the argument was given to add this system to AD do so here
  if ad_admin:
    # rhel/centos 6 and rhel/centos 7 kernel versions
    if re.match(r'^2.6.32', kver) or re.match(r'^3.10', kver):
      chk_pkgs('samba', 'samba-common', 'samba-winbind', 'krb5-libs', 'krb5-workstation', 'pam_krb5', 'krb5-auth-dialog', 'samba-winbind-clients')
    # rhel/centos 5
    elif re.match(r'^2.6.18', kver):
      # Some issues with RHEL 5 - needs to be tested further...just exit for now
      print "This appears to be a RHEL/CentOS 5 system. This OS is not supported by this script at this time."
      sys.exit(1)
      #chk_pkgs('samba3x', 'samba3x-common', 'samba3x-winbind', 'krb5-libs', 'krb5-workstation', 'pam_krb5', 'krb5-auth-dialog', 'authconfig-gtk')
    else:
      print "Warning: could not determine if this is a RHEL/CentOS 5 or 6 system for requisite package check."
      pass
    add_to_ad(ad_admin)

# Main execute here.
if __name__ == "__main__":
  main(sys.argv[1:])

